/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_data_queue.h
 *
 *	@brief	Windows iTRONT[rXR[ (f[^L[).
 *
 *	@author	V 閾
 */
#ifndef	__WI_DATA_QUEUE_H__
#define	__WI_DATA_QUEUE_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief f[^L[IuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute;		//!< f[^L[.
	UINT		QueSize;		//!< f[^L[̈̌.
	DWORD		*QueBuf;		//!< f[^L[̈̐擪AhX.
	DWORD		GetPos;			//!< [̓ǂݏoʒu.
	DWORD		PutPos;			//!< [̏oʒu.
	WIHDR		*SndWaitQue;	//!< ^XN̑M҂s̃|C^.
	WIHDR		*RcvWaitQue;	//!< ^XN̎M҂s̃|C^.
} WIDTQOBJ;

/*!
 *
 * @brief f[^L[Ԃ̎QƗp\.
 *
 */
typedef struct {
	INT			SndWaitId;			//!< f[^L[̑M҂s̐擪̃^XNIDԍ.
	INT			RcvWaitId;			//!< f[^L[̎M҂s̐擪̃^XNIDԍ.
	INT			DataCnt;			//!< f[^L[ɓĂf[^.
} WIDTQSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitDataQueue( void );
void	wi_QuitDataQueue( void );
ER		wi_CreateDataQueue( INT id, const WIDTQOBJ *obj );
ER		wi_DeleteDataQueue( INT id );
ER		wi_SendDataQueue( INT id, DWORD data, TMO tmout );
ER		wi_ForceSendDataQueue( INT id, DWORD data );
ER		wi_ReceiveDataQueue( INT id, DWORD *data, TMO tmout );
ER		wi_RefarenceDataQueue(  INT id, WIDTQSTAT *sts );
void	wi_AllReleaseDataQueue( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_DATA_QUEUE_H__
/* End of file */
