/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_semaphore.h
 *
 *	@brief	Windows iTRONT[rXR[ (Z}tH).
 *
 *	@author	V 閾
 */
#ifndef	__WI_SEMAPHORE_H__
#define	__WI_SEMAPHORE_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief Z}tHIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute;		//!< Z}tH.
	INT			SemCnt;			//!< ݂̃Z}tHJEg.
	INT			MaxCnt;			//!< Z}tHJEg̍ő吔.
	VP			ExtInfo;		//!< g.
	WIHDR		*WaitQue;		//!< Z}tHl҂̑҂s̃|C^.
} WISEMOBJ;

/*!
 *
 * @brief Z}tH̏ԎQƗp\.
 *
 */
typedef struct {
	INT			WaitId;			//!< Z}tH҂s̐擪̃^XNIDԍ.
	INT			SemCnt;			//!< ݂̃Z}tHJEgl.
	VP			ExtInfo;		//!< g.
} WISEMSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitSemaphore( void );
void	wi_QuitSemaphore( void );
ER		wi_CreateSemaphore( INT id, const WISEMOBJ *obj );
ER		wi_DeleteSemaphore( INT id );
ER		wi_SignalSemaphore( INT id );
ER		wi_WaitSemaphore( INT id, TMO tmout );
ER		wi_RefarenceSemaphore( INT id, WISEMSTAT *sts );
void	wi_AllReleaseSemaphore( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_SEMAPHORE_H__
/* End of file */
