/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_variable_mempool.h
 *
 *	@brief	Windows iTRONT[rXR[ (ϒv[).
 *
 *	@author	V 閾
 */
#ifndef	__WI_VARIABLE_MEMPOOL_H__
#define	__WI_VARIABLE_MEMPOOL_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief ϒIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;				//!< IuWFNgwb_.
	VP			ExtInfo;			//!< g.
	ATR			Attribute; 			//!< ϒv[.
	INT			MemSize;			//!< ϒv[̃TCY.
	BYTE		*MemBuf;			//!< ϒv[̃f[^obt@̃|C^.
	WIHDR		*WaitQue;			//!< ^XN̑҂s̃|C^.
} WIMPLOBJ;

/*!
 *
 * @brief ϒ̏ԎQƗp\.
 *
 */
typedef struct {
	INT			WaitId;				//!< ҂s̐擪̃^XNIDԍ.
	INT			TotalFreeSize;		//!< 󂫗̈̍vTCY.
	INT			MaxFreeSize;		//!< ő̘A󂫗̈̃TCY.
	VP			ExtInfo;			//!< g.
} WIMPLSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitVarMemPool( void );
void	wi_QuitVarMemPool( void );
ER		wi_CreateVarMemPool( INT id, const WIMPLOBJ *obj );
ER		wi_DeleteVarMemPool( INT id );
ER		wi_GetVarMemPool( INT id, VP adr, INT size, TMO tmout );
ER		wi_ReleaseVarMemPool( INT id, VP adr );
ER		wi_RefarenceVarMemPool( INT id, WIMPLSTAT *sts );
void	wi_AllReleaseVarMemPool( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_VARIABLE_MEMPOOL_H__
/* End of file */
