/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_fixed_mempool.h
 *
 *	@brief	Windows iTRONT[rXR[ (Œ蒷v[).
 *
 *	@author	V 閾
 */
#ifndef	__WI_FIXED_MEMPOOL_H__
#define	__WI_FIXED_MEMPOOL_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief Œ蒷v[IuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute; 		//!< Œ蒷v[̑.
	INT			BlockCnt; 		//!< Œ蒷v[Ŝ̃ubN.
	INT			BlockSize;		//!< Œ蒷ubÑTCY.
	BYTE*		MemBuf;			//!< obt@̃|C^.
	WIHDR		*FreeQue;		//!< gp̌Œ蒷ubNÑ|C^.
	WIHDR		*UsedQue;		//!< ݂ǒŒ蒷ubNÑ|C^.
	WIHDR		*WaitQue;		//!< ^XN̑҂s̃|C^.
	VP			ExtInfo;		//!< g.
} WIMPFOBJ;

/*!
 *
 * @brief Œ蒷v[̏ԎQƗp\.
 *
 */
typedef struct {
	INT			WaitId;				//!< ubNl҂s̐擪̃^XNIDԍ.
	INT			FreeBlock;			//!< 󂫃ubŇ.
	VP			ExtInfo;			//!< g.
} WIMPFSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitFixedMemPool( void );
void	wi_QuitFixedMemPool( void );
ER		wi_CreateFixedMemPool( INT id, const WIMPFOBJ *obj );
ER		wi_DeleteFixedMemPool( INT id );
ER		wi_GetFixedMemPool( INT id, VP buf, TMO tmout );
ER		wi_ReleaseFixedMemPool( INT id, VP blf );
ER		wi_RefarenceFixedMemPool( INT id, WIMPFSTAT *sts );
void	wi_AllReleaseFixedMemPool( INT task_id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_FIXED_MEMPOOL_H__
/* End of file */
