/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_mutex.h
 *
 *	@brief	Windows iTRONT[rXR[ (~[ebNX).
 *
 *	@author	V 閾
 */
#ifndef	__WI_MUTEX_H__
#define	__WI_MUTEX_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief ~[ebNXIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute;		//!< ~[ebNX.
	PRI			CeilPri;		//!< ~[ebNX̏Dx.
	INT			LockId;			//!< ~[ebNXbNĂ^XNIDԍ.
	WIHDR		*WaitQue;		//!< Z}tHl҂̑҂s̃|C^.
} WIMTXOBJ;

/*!
 *
 * @brief ~[ebNX̏ԎQƗp\.
 *
 */
typedef struct {
	INT			LockId;			//!< ~[ebNXbNĂ^XNIDԍ.
	INT			WaitId;			//!< ~[ebNX҂s̐擪̃^XNIDԍ.
} WIMTXSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitMutex( void );
void	wi_QuitMutex( void );
ER		wi_CreateMutex( INT id, const WIMTXOBJ *obj );
ER		wi_DeleteMutex( INT id );
ER		wi_LockMutex( INT id, TMO tmout );
ER		wi_UnlockMutex( INT id );
ER		wi_RefarenceMutex( INT id, WIMTXSTAT *sts );
void	wi_AllReleaseMutex( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_MUTEX_H__
/* End of file */
